# Maintainer: Christoph Schmidpeter <john.doe@example.com>
# Co-Maintainer: Mubashshir <ahmubashshir@gmail.com>
# Contributor: Iwan Timmer <irtimmer@gmail.com>

_pkgname=anbox
pkgname=${_pkgname}-git
pkgver=r1358.84f0268
pkgrel=6
epoch=1
arch=('x86_64')
url="http://anbox.io"
license=('GPL3')
makedepends=('boost' 'cmake' 'dbus' 'git' 'glm' 'gtest' 'lxc-git' 'protobuf' 'properties-cpp' 'python' 'sdbus-cpp' 'sdl2_image' 'systemd' 'imagemagick')
source=("git+https://github.com/anbox/anbox.git"
        "git+https://github.com/google/cpu_features.git"
        'lxc.patch::https://gitlab.alpinelinux.org/alpine/aports/-/raw/fc60972afd4ff0c096498e28557b9a16e801aa7f/community/anbox/lxc4.patch'
        'sdbus.patch::https://gitlab.alpinelinux.org/alpine/aports/-/raw/fc60972afd4ff0c096498e28557b9a16e801aa7f/community/anbox/no-bundled-sdbus.patch'
        'delayed-start.patch::https://gitlab.alpinelinux.org/alpine/aports/-/raw/70a1a8afb7b6ac37291d382e6e5cc7561fc88626/community/anbox/give-more-time-to-start.patch'
        "https://metainfo.manjariando.com.br/${_pkgname}/org.${_pkgname}.metainfo.xml"
        "https://metainfo.manjariando.com.br/${_pkgname}/org.${_pkgname}.desktop"
        'anbox-container-manager.service'
        'anbox-session-manager.service'
        'anbox-bridge.network'
        'anbox-bridge.netdev'
        'dev-binderfs.mount'
        'org.anbox.service'
        '99-anbox.rules'
        'anbox.conf')
sha256sums=('SKIP'
            'SKIP'
            'c1071203defdeaee56122913a6d7e67ac496c889a0c59cb889d94a58bc655bfa'
            '7c0626afaf1ce004ac2c57cd89db393f9a6ba21f1087001d15278a7bd79c8219'
            '253c211455ff0cfaa058a0b80eb41d58f84ee646c0c67dbcbcc888b5833009a7'
            'd40c989a4c53d408d5d677920ff7b3276368a4e0d4d8604b62bcdc00bd4f5af1'
            '3f515f1c525b75a21b90116f1bea54d88793b654c139810cca8e14a36fe78648'
            'be18c27f349560d46f7d7912b3b84d503e477fb643c55e4a7d6de9a84be93d0b'
            '1f22dbb5a3ca6925bbf62899cd0f0bbaa0b77c879adcdd12ff9d43adfa61b1d8'
            '44899328725667041e6e84912da81c1d0147b708006eb2c2bb6503f271629ff0'
            '559190df4d6d595480b30d8b13b862081fc4aac52790e33eb24cf7fbcb8003b8'
            'c7e9958a9cff1191dca0d50b0ea8392d7728490e56ffb38a475ba516a09a2109'
            '74e2208e0c03e5f21be3ff54b58160a172e3768a80c41726c06b4ab8cc9288dd'
            '210eb93342228168f7bb632c8b93d9bfda6f53f62459a6b74987fa1e17530475'
            '3e07dc524a827c1651857cce28a06c1565bc5188101c140ed213bbafedc5abff')

pkgver() {
    cd "${pkgname%*-git}"
    ( set -o pipefail
        git describe --long 2>/dev/null | sed 's/\([^-]*-g\)/r\1/;s/-/./g' ||
        printf "r%s.%s" "$(git rev-list --count HEAD)" "$(git rev-parse --short HEAD)"
    )
}

prepare() {
    cd "${pkgname%*-git}"

    # Don't build tests
    truncate -s 0 cmake/FindGMock.cmake
    truncate -s 0 tests/CMakeLists.txt
    sed -i '1i\#include <cstdint>' "$srcdir/anbox/src/anbox/input/manager.cpp"
    for each in lxc sdbus delayed-start;do
        patch -p1 < "$srcdir/$each.patch"
    done

    git submodule init
    git config submodule.external/cpu_features.url $srcdir/cpu_features
    git config --remove-section submodule.external/sdbus-cpp
    git submodule update
}

build() {
    cmake -B build -S "${pkgname%*-git}" \
        -DCMAKE_INSTALL_LIBDIR=lib \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_BUILD_TYPE=None \
        -DCMAKE_SKIP_INSTALL_RPATH=YES \
        -DCMAKE_SKIP_RPATH=YES \
        -Wno-dev
    make -C build
}

package() {
    pkgdesc="Running Android in a container"
    depends=('lxc-git' 'sdl2_image' 'protobuf' 'libsystemd' 'boost-libs' 'android-udev' 'anbox-image-gapps' 'linux>5.9' 'sdbus-cpp')
    provides=('anbox')
    conflicts=('anbox' 'anbox-modules' 'linux<5.9')

    make -C build DESTDIR="$pkgdir" install

    install -Dm 644 -t "$pkgdir/usr/lib/systemd/system"     anbox-container-manager.service dev-binderfs.mount
    install -Dm 644 -t "$pkgdir/usr/lib/systemd/user"       anbox-session-manager.service
    install -Dm 644    "$srcdir/anbox-bridge.network"       "$pkgdir/usr/lib/systemd/network/80-anbox-bridge.network"
    install -Dm 644    "$srcdir/anbox-bridge.netdev"        "$pkgdir/usr/lib/systemd/network/80-anbox-bridge.netdev"
    install -Dm 644 -t "$pkgdir/usr/lib/udev/rules.d"       99-anbox.rules
    install -Dm 644 -t "$pkgdir/usr/share/dbus-1/services"  org.anbox.service
    install -Dm 644 -t ${pkgdir}/usr/share/applications ${srcdir}/org.${_pkgname}.desktop
    install -Dm 644 ${_pkgname}/snap/gui/icon.png ${pkgdir}/usr/share/pixmaps/anbox.png
    install -Dm 644 "${srcdir}/org.${_pkgname}.metainfo.xml" "${pkgdir}/usr/share/metainfo/org.${_pkgname}.metainfo.xml"

    for size in 22 24 32 48 64 128 256 512; do
        mkdir -p "${pkgdir}/usr/share/icons/hicolor/${size}x${size}/apps"
        convert "${srcdir}/${_pkgname}/snap/gui/icon.png" -resize "${size}x${size}" \
            "${pkgdir}/usr/share/icons/hicolor/${size}x${size}/apps/${_pkgname}.png"
    done
}
